---
title: WebGL2RenderingContext.drawBuffers()
slug: Web/API/WebGL2RenderingContext/drawBuffers
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGL2
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGL2RenderingContext.drawBuffers()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL 2 API</a> defines draw buffers to which fragment colors are written into. The draw buffer settings are part of the state of the currently bound framebuffer or the drawingbuffer if no framebuffer is bound.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">void <var>gl</var>.drawBuffers(<var>buffers</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>buffers</code></dt>
 <dd>An {{jsxref("Array")}} of {{domxref("GLenum")}} specifying the buffers into which fragment colors will be written. Possible values are:
 <ul>
  <li><code>gl.NONE</code>: Fragment shader output is not written into any color buffer.</li>
  <li><code>gl.BACK</code>: Fragment shader output is written into the back color buffer.</li>
  <li><code>gl.COLOR_ATTACHMENT{0-15}</code>: Fragment shader output is written in the nth color attachment of the current framebuffer.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h3 id="Exceptions">Exceptions</h3>

<ul>
 <li>If <code>buffers</code> contains not one of the accepted values, a <code>gl.INVALID_ENUM</code> error is thrown.</li>
</ul>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">gl.drawBuffers([gl.NONE, gl.COLOR_ATTACHMENT1]);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.11", "drawBuffers")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glDrawBuffers.xhtml", "glDrawBuffers")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGL2RenderingContext.drawBuffers")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGL2RenderingContext.clearBuffer", "WebGL2RenderingContext.clearBuffer[fiuv]()")}}</li>
</ul>
